Item = class{function(self, x,y, what)
	self.img = what
	if type(self.img) ~= "userdata" then
		if not self.img:match("%.png$") then self.img = self.img..".png" end
		self.img = IMG[self.img]
	end
	self.w,self.h = case (what) {
		[IMG['shotgun.png']] = function() return 32,10 end,
		[IMG['pistol.png']] = function() return 16,11 end,
		default = function() return self.img:getWidth(), self.img:getHeight() end,
	}

	self.pos = vector(x-self.w, y-self.h)
	self.shape = HC.addRectangle(self.pos.x,self.pos.y, self.w,self.h)
	self.shape.object = self
	HC.addToGroup('item', self.shape)
	
	self.weapon = case (self.img) {
		[IMG['shotgun.png']] = Shotgun(self.pos.x,self.pos.y,1),
		default = Pistol(self.pos.x,self.pos.y,1)
	}

	self.scale = .5
	self.osc = Timer.Oscillator(2, function(t)
		local f = (1 + math.sin(t * math.pi * 2))/2
		self.scale = (f * .2) + .7
	end)

	Entities.register(self)
end}
make_collidable(Item)

function Item:draw()
	love.graphics.setColor(255,255,255)
	love.graphics.draw(self.img, self.pos.x+self.w/2,self.pos.y+self.h/2, 0, self.scale,self.scale, self.w/2,self.h/2)
end

function Item:update(dt)
	self.osc(dt)
end
