Weapon = class{function(self,x,y,direction,img, delay, damage)
	self.pos = vector(x,y)
	self.offset = vector(0,0)
	self.anim_offset = vector(0,0)
	self.direction = direction
	self.may_fire = true
	self.img = img
	self.delay = delay or .4
	self.damage = damage or .1
end}

function Weapon:draw()
	local x = self.pos.x + (self.offset.x + self.anim_offset.x) * self.direction
	local y = self.pos.y + (self.offset.y + self.anim_offset.y)
	love.graphics.draw(self.img, x,y, 0, self.direction*.5,.5,
		self.img:getWidth()/2, self.img:getHeight()/2)
end

NullWeapon = class{inherits = Weapon, function(self)
	Weapon.construct(self,0,0,1, IMG['transparent.png'])
	self.null_weapon = true
end}
function NullWeapon:draw() end
function NullWeapon:shoot() end



Pistol = class{inherits = Weapon, function(self,x,y,direction, delay, damage)
	Weapon.construct(self, x,y, direction, IMG['pistol.png'], delay, damage)
	self.offset.x = 7
	self.offset.y = 1.5
end}

function Pistol:shoot()
	if not self.may_fire then return end
	local x,y = self.pos:unpack()
	x = x + self.img:getWidth()/2 * self.direction
	y = y + self.direction

	Bullet(self.damage, x,y, self.direction, 0, self.damage)
	self.may_fire = false
	Timer.add(self.delay, function() self.may_fire = true end)

	love.audio.play('snd/Pistol.ogg')
end



Shotgun = class{inherits = Weapon, function(self,x,y,direction, delay, damage)
	Weapon.construct(self, x,y, direction, IMG['shotgun.png'], delay or 1, damage or .075)
	self.offset.x = 6
	self.offset.y = 1.5
end}

function Shotgun:shoot()
	if not self.may_fire then return end
	local v = vector(self.direction,0)
	local x,y = self.pos:unpack()
	x = x + self.img:getWidth()/2 * self.direction
	y = y + self.direction

	local function rand_dir()
		return (v + vector(0, (math.random()-.5)*.4)):normalize_inplace():unpack()
	end

	Bullet(self.damage, x,y, rand_dir())
	Bullet(self.damage, x,y, rand_dir())
	Bullet(self.damage, x,y, rand_dir())
	Bullet(self.damage, x,y, rand_dir())

	self.may_fire = false
	Timer.add(self.delay, function() self.may_fire = true end)

	love.audio.play('snd/Gun.ogg')
end
