function make_collidable(cls)
	cls._onCollide = {}
	cls._onStopCollide = {}

	function cls:onCollide(group, reaction)
		self._onCollide[group] = reaction
	end

	function cls:onStopCollide(group, reaction)
		self._onStopCollide[group] = reaction
	end

	function cls:register(group, onCollide, onStop)
		cls:onCollide(group, onCollide)
		cls:onStopCollide(group, onStop)
	end

	function cls:collideWith(other,dx,dy)
		for group,_ in pairs(other.shape._groups) do
			if self._onCollide[group] then
				return self._onCollide[group](self, other, dx,dy)
			end
		end
	end

	function cls:stopCollideWith(other,dx,dy)
		for group,_ in pairs(other.shape._groups) do
			if self._onStopCollide[group] then
				return self._onStopCollide[group](self, other, dx,dy)
			end
		end
	end

end
